---
title: Using the aria-describedby attribute
slug: Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-describedby_attribute
tags:
  - ARIA
  - Accessibility
  - Attribute
---
<h3 id="Description">Description</h3>

<p><span class="seoSummary">The <a class="external" href="https://www.w3.org/TR/wai-aria/#aria-describedby" rel="external" title="https://www.w3.org/TR/wai-aria/#aria-describedby"><code>aria-describedby</code></a> attribute is used to indicate the IDs of the elements that describe the object. It is used to establish a relationship between widgets or groups and text that described them. This is very similar to <a href="/en/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute" title="Using the aria-labelledby attribute">aria-labelledby</a>: a label describes the essence of an object, while a description provides more information that the user might need.</span></p>

<p>The <code>aria-describedby</code> attribute is not used only for form elements; it is also used to associate static text with widgets, groups of elements, panes, regions that have a heading, definitions, and more. The {{ anch("Examples") }} section below provides more information about how to use the attribute in these cases.</p>

<p>This attribute can be used with any typical HTML form element; it is not limited to elements that have an ARIA <code>role</code> assigned.</p>

<h3 id="Value">Value</h3>

<p>a space-separated list of element IDs</p>

<h3 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology </h3>

<div class="note"><strong>Note:</strong> Opinions may differ on how assistive technology should handle this technique. The information provided above is one of those opinions and therefore not normative.</div>

<h3 id="Examples">Examples</h3>

<h4 id="Example_1_Application_Landmark_Descriptions">Example 1: Application Landmark Descriptions</h4>

<p>In the example below, an introductory paragraph describes a calendar application. <code>aria-describedby</code> is used to associate the paragraph with the application container.</p>

<pre class="brush: html notranslate">&lt;div role="application" aria-labelledby="calendar" aria-describedby="info"&gt;
    &lt;h1 id="calendar"&gt;Calendar&lt;/h1&gt;
    &lt;p id="info"&gt;
        This calendar shows the game schedule for the Boston Red Sox.
    &lt;/p&gt;
    &lt;div role="grid"&gt;
        ...
    &lt;/div&gt;
&lt;/div&gt;
</pre>

<h4 id="Example_2_A_Close_Button">Example 2: A Close Button</h4>

<p>In the example below, a link that functions as a 'close' button on a dialog is described elsewhere in the document. The aria-describedby attribute is used to associate the description with the link.</p>

<pre class="brush: html notranslate">&lt;button aria-label="Close" aria-describedby="descriptionClose"
    onclick="myDialog.close()"&gt;X&lt;/button&gt;

...

&lt;div id="descriptionClose"&gt;Closing this window will discard any information entered and
return you back to the main page&lt;/div&gt;
</pre>

<h3 id="Notes">Notes </h3>

<ul>
 <li>The <code>aria-describedby</code> attributed is not designed to reference descriptions on an external resource—since it is an ID, it must reference an element in the same DOM document.</li>
</ul>

<h3 id="Used_by_ARIA_roles">Used by ARIA roles</h3>

<p>all elements of the base markup</p>

<h3 id="Related_ARIA_techniques">Related ARIA techniques </h3>

<ul>
 <li><a href="/en/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute" title="en/ARIA/ARIA_Techniques/Using_the_aria-labelledby_attribute">Using the aria-labelledby attribute</a></li>
</ul>

<h3 id="Compatibility">Compatibility</h3>

<p class="comment">TBD: Add support information for common UA and AT product combinations</p>

<h3 id="Additional_resources">Additional resources</h3>

<ul>
 <li><a class="external" href="https://www.w3.org/TR/wai-aria/#aria-describedby">WAI-ARIA specification for aria-describedby</a></li>
</ul>
